diff --git a/common/src/main/scala/services/teamwork/SquadService.scala b/common/src/main/scala/services/teamwork/SquadService.scala
index 2c22886c..b837e7a1 100644
--- a/common/src/main/scala/services/teamwork/SquadService.scala
+++ b/common/src/main/scala/services/teamwork/SquadService.scala
@@ -2211,11 +2990,62 @@ object SquadService {
     }
   }
 
-  def ValidOpenSquadPosition(squad : Squad, position : Int, member : Member, reqs : Set[CertificationType.Value]) : Boolean = {
-    ValidSquadPosition(squad, position, member, reqs) && member.CharId == 0
+  /**
+    * Determine if the indicated squad role can be used for a player trying to join the squad.
+    * @see `ValidOpenSquadPosition`
+    * @param squad the squad
+    * @param position the position of the squad role being tested
+    * @param certs the certifications being offered for comparison testing
+    * @return `true`, if the squad role may accept the player with the given certification permissions;
+    *        `false`, otherwise
+    */
+  def ValidOpenSquadPosition(squad : Squad, position : Int, certs : Set[CertificationType.Value]) : Boolean = {
+    squad.Membership.lift(position) match {
+      case Some(member) =>
+        ValidOpenSquadPosition(squad, position, member, certs)
+      case None =>
+        false
+    }
   }
 
-  def ValidSquadPosition(squad : Squad, position : Int, member : Member, reqs : Set[CertificationType.Value]) : Boolean = {
-    squad.Availability(position) && reqs.intersect(member.Requirements) == member.Requirements
+  /**
+    * Determine if the indicated squad role can be used for a player trying to join the squad.
+    * @see `AvailableSquadPosition`
+    * @param squad the squad
+    * @param position the position of the squad role being tested
+    * @param member the squad role being tested
+    * @param certs the certifications being offered for comparison testing
+    * @return `true`, if the squad role may accept the player with the given certification permissions;
+    *        `false`, otherwise
+    */
+  def ValidOpenSquadPosition(squad : Squad, position : Int, member : Member, certs : Set[CertificationType.Value]) : Boolean = {
+    AvailableSquadPosition(squad, position, member) && certs.intersect(member.Requirements) == member.Requirements
+  }
+
+  /**
+    * Determine if the indicated squad role is unoccupied but is also capable of being occupied.
+    * @see `AvailableSquadPosition(Squad, Int, Member)`
+    * @param squad the squad
+    * @param position the position of the squad role being tested
+    * @return `true`, if the squad role is unoccupied;
+    *        `false`, otherwise
+    */
+  def AvailableSquadPosition(squad : Squad, position : Int) : Boolean = squad.Membership.lift(position) match {
+    case Some(member) =>
+      AvailableSquadPosition(squad, position, member)
+    case None =>
+      false
+  }
+
+  /**
+    * Determine if the indicated squad role is unoccupied but is also capable of being occupied.
+    * @param squad the squad
+    * @param position the position of the squad role being tested
+    * @param member the squad role being tested
+    * @return `true`, if the squad role is unoccupied;
+    *        `false`, otherwise
+    */
+  def AvailableSquadPosition(squad : Squad, position : Int, member : Member) : Boolean = {
+    squad.Availability(position) && member.CharId == 0
   }
 }
diff --git a/common/src/main/scala/services/teamwork/SquadServiceResponse.scala b/common/src/main/scala/services/teamwork/SquadServiceResponse.scala
index 5e6bc998..47cf0387 100644
--- a/common/src/main/scala/services/teamwork/SquadServiceResponse.scala
+++ b/common/src/main/scala/services/teamwork/SquadServiceResponse.scala
@@ -1,7 +1,14 @@
 // Copyright (c) 2019 PSForever
 package services.teamwork
 
-import net.psforever.packet.game.SquadInfo
 import services.GenericEventBusMsg
 
-final case class SquadServiceResponse(toChannel : String, response : SquadResponse.Response) extends GenericEventBusMsg
+final case class SquadServiceResponse(toChannel : String, exclude : Iterable[Long], response : SquadResponse.Response) extends GenericEventBusMsg
+
+object SquadServiceResponse {
+  def apply(toChannel : String, response : SquadResponse.Response) : SquadServiceResponse =
+    SquadServiceResponse(toChannel, Nil, response)
+
+  def apply(toChannel : String, exclude : Long, response : SquadResponse.Response) : SquadServiceResponse =
+    SquadServiceResponse(toChannel, Seq(exclude), response)
+}
